﻿Imports System.IO

Public Class FormGsiJobs

    Public projektAktiven
    Public projektAktivenMapa
    Public projektIzbran
    Public projektIzbranMapa
    Public jobIzbran
    Public jobDatoteka

    ' Funkcije izvedene pri nalaganju okna
    Private Sub FormGsiJobs_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        projektAktiven = My.Settings.Projekt.ToString
        projektAktivenMapa = My.Settings.ProjektMapa.ToString
        LabelDeloProj.Text = projektAktiven
        LabelDeloMapa.Text = projektAktivenMapa

        ProjektBeriNast()


    End Sub

    Public Sub ProjektBeriNast()
        Dim datProjektiNast = "tps1100_projekti.txt"
        Dim i As Integer = 0
        Dim iselected As Integer = 0
        ' Uvoz nastavitev iz datototeke
        If My.Computer.FileSystem.FileExists(datProjektiNast) Then
            Dim streamReader As StreamReader = New StreamReader(datProjektiNast)
            Do Until streamReader.EndOfStream
                ' Read and Split each line to separate it into fields
                Dim line() As String = streamReader.ReadLine().Split("=")

                If (line(0) IsNot "") Then
                    Dim projIme As String = line(0)
                    Dim projMapa As String = line(1)

                    ListViewProj.Items.Add(projIme).SubItems.Add(projMapa)
                    If projIme = My.Settings.Projekt Then
                        iselected = i
                    End If
                    i = i + 1
                End If

            Loop

            streamReader.Close()
            streamReader.Dispose()
            My.Settings.Save()
            ListViewProj.Items.Item(iselected).Selected = True
            ListViewProj.Focus()
        Else
            ' Izvoz kodiranja v TXT datoteko
            Dim dataNast As String = ""

            dataNast = dataNast + "Virtualna Kartica=Virtualna Kartica\GSI" + vbCrLf
            dataNast = dataNast + "Test Projekt=Projekti\Test Projekt" + vbCrLf

            My.Computer.FileSystem.WriteAllText(datProjektiNast, dataNast, False)
        End If

    End Sub

    Public Sub ProjektiShraniNast()
        Dim datProjektiNast = "tps1100_projekti.txt"
        ' Uvoz nastavitev iz datototeke
        If My.Computer.FileSystem.FileExists(datProjektiNast) Then
            Dim dataProj As ListView.ListViewItemCollection = Me.ListViewProj.Items
            Dim item As ListViewItem
            Dim ime As String = ""
            Dim mapa As String = ""
            Dim dataOut As String = ""
            For Each item In dataProj
                ime = item.SubItems(0).Text
                mapa = item.SubItems(1).Text
                dataOut = dataOut + ime + "=" + mapa + vbCrLf
            Next
            My.Computer.FileSystem.WriteAllText(datProjektiNast, dataOut, False)
        End If
    End Sub

    Private Sub UvoziGsiJob()
        If OpenFileDialogUvoziJob.ShowDialog = DialogResult.OK Then
            Dim delovnaMapa = My.Application.Info.DirectoryPath.ToString + "\" + My.Settings.ProjektMapa.ToString + "\"
            Dim fileUvoz = OpenFileDialogUvoziJob.FileName
            Dim fileIme = Path.GetFileName(OpenFileDialogUvoziJob.FileName)
            Dim fileIzvoz = delovnaMapa + fileIme
            My.Computer.FileSystem.CopyFile(fileUvoz, fileIzvoz, True)
            OpenFileDialogUvoziJob.FileName = fileIzvoz

        End If

        OpenFileDialogUvoziJob.Dispose()
    End Sub

    Private Sub NastaviDelovniProj()
        LabelDeloProj.Text = LabelIzbProj.Text
        LabelDeloMapa.Text = LabelIzbProjMapa.Text
        My.Settings.Projekt = LabelDeloProj.Text
        My.Settings.ProjektMapa = LabelDeloMapa.Text
        My.Settings.Save()
        If LabelDeloProj.Text = "Virtualna Kartica" Then
            Form1.ToolStripLabel2.Text = LabelDeloProj.Text
            Form1.ToolStripLabel2.Image = My.Resources.icons8_micro_sd_50
        Else
            Form1.ToolStripLabel2.Text = LabelDeloProj.Text
            Form1.ToolStripLabel2.Image = My.Resources.icons8_browse_folder_50_2
        End If
    End Sub

    Private Sub NaloziJob()
        LabelDeloProj.Text = LabelIzbProj.Text
        LabelDeloMapa.Text = LabelIzbProjMapa.Text
        My.Settings.Projekt = LabelDeloProj.Text
        My.Settings.ProjektMapa = LabelDeloMapa.Text
        My.Settings.Save()
        If LabelDeloProj.Text = "Virtualna Kartica" Then
            Form1.ToolStripLabel2.Text = LabelDeloProj.Text
            Form1.ToolStripLabel2.Image = My.Resources.icons8_micro_sd_50
        Else
            Form1.ToolStripLabel2.Text = LabelDeloProj.Text
            Form1.ToolStripLabel2.Image = My.Resources.icons8_browse_folder_50_2
        End If
        Form1.datJob = TextBoxJobDat.Text
        Form1.NaloziGsiJob()
        Me.Close()
    End Sub

    Private Sub PreberiJobe()
        Dim izbran As ListView.SelectedListViewItemCollection = Me.ListViewProj.SelectedItems
        Dim item As ListViewItem
        Dim ime As String = ""
        Dim mapa As String = ""
        For Each item In izbran
            ime = item.SubItems(0).Text
            mapa = item.SubItems(1).Text
        Next
        LabelIzbProj.Text = ime.ToString
        LabelIzbProjMapa.Text = mapa.ToString
        Dim delovnaMapa = My.Application.Info.DirectoryPath.ToString + "\" + mapa.ToString
        projektIzbran = ime.ToString
        projektIzbranMapa = delovnaMapa
        Dim datotekeJobi = My.Computer.FileSystem.GetFiles(delovnaMapa, FileIO.SearchOption.SearchTopLevelOnly, "*.GSI")
        ListView2.Clear()
        For Each datJob In datotekeJobi
            ListView2.Items.Add(Path.GetFileName(datJob).ToString).SubItems.Add(Path.GetFullPath(datJob))
        Next
        If ime = "Virtualna Kartica" Then
            ToolStripButton1.Enabled = False
            ToolStripButton2.Enabled = False
            ToolStripButton6.Enabled = False
            ToolStripButton7.Enabled = False
        Else
            ToolStripButton1.Enabled = True
            ToolStripButton2.Enabled = True
            ToolStripButton6.Enabled = False
            ToolStripButton7.Enabled = False
        End If
    End Sub

    Private Sub ListViewProj_SelectedIndexChanged(sender As Object, e As EventArgs) Handles ListViewProj.SelectedIndexChanged
        PreberiJobe()
    End Sub

    Private Sub ListViewProj_DoubleClick(sender As Object, e As EventArgs) Handles ListViewProj.DoubleClick
        NastaviDelovniProj()
        Me.Close()
    End Sub

    Private Sub ButtonDelovni_Click(sender As Object, e As EventArgs) Handles ButtonDelovni.Click, ToolStripButton5.Click
        NastaviDelovniProj()
    End Sub

    Private Sub ListView2_SelectedIndexChanged(sender As Object, e As EventArgs) Handles ListView2.SelectedIndexChanged
        Dim izbran As ListView.SelectedListViewItemCollection = Me.ListView2.SelectedItems
        Dim item As ListViewItem
        Dim ime As String = ""
        Dim mapa As String = ""
        For Each item In izbran
            ime = item.SubItems(0).Text
            mapa = item.SubItems(1).Text
        Next
        LabelJobIme.Text = ime.ToString
        TextBoxJobDat.Text = mapa.ToString
        If LabelJobIme.Text = "" Then
            ButtonNalJob2.Enabled = False
            ToolStripButton6.Enabled = False
            ToolStripButton7.Enabled = False
        Else
            ButtonNalJob2.Enabled = True
            ToolStripButton6.Enabled = True
            ToolStripButton7.Enabled = True
        End If

        'Dim delovnaJob = My.Application.Info.DirectoryPath.ToString + "\" + mapa.ToString
        'projektIzbran = ime.ToString
        'projektIzbranMapa = delovnaMapa
        'Dim datotekeJobi = My.Computer.FileSystem.GetFiles(delovnaMapa, FileIO.SearchOption.SearchTopLevelOnly, "*.GSI")
    End Sub

    Private Sub ListView2_DoubleClick(sender As Object, e As EventArgs) Handles ListView2.DoubleClick
        NaloziJob()

    End Sub

    Private Sub ToolStripButton4_Click(sender As Object, e As EventArgs) Handles ToolStripButton4.Click
        DialogNovProj.ShowDialog()

    End Sub

    Private Sub ToolStripButton3_Click(sender As Object, e As EventArgs) Handles ToolStripButton3.Click
        Process.Start(projektIzbranMapa)
    End Sub

    Private Sub TSButtonUvozi_Click(sender As Object, e As EventArgs) Handles TSButtonUvozi.Click
        UvoziGsiJob()
    End Sub

    Private Sub TSButonNalozi_Click(sender As Object, e As EventArgs) Handles TSButonNalozi.Click, ButtonNalJob2.Click
        NaloziJob()

    End Sub

    Private Sub ToolStripButton7_Click(sender As Object, e As EventArgs) Handles ToolStripButton7.Click
        ' Arhiviraj izbran job
        Dim datIzb = TextBoxJobDat.Text
        Dim datArh = datIzb.Replace(LabelJobIme.Text, "_ARHIV\" + LabelJobIme.Text)

        Dim msgArh = MsgBox("Arhiviram job: " + LabelJobIme.Text, vbOKCancel, "Arhiviranje Job-a...")
        If msgArh = DialogResult.OK Then
            If My.Computer.FileSystem.FileExists(datIzb) Then
                My.Computer.FileSystem.MoveFile(datIzb, datArh, True)
            End If
            ' Ponovno osveži vsebino seznama
            PreberiJobe()
        End If
    End Sub

    Private Sub ToolStripButton6_Click(sender As Object, e As EventArgs) Handles ToolStripButton6.Click
        ' Izbriši izbran job
        Dim datIzb = TextBoxJobDat.Text

        Dim msgArh = MsgBox("Izbrišem job: " + LabelJobIme.Text, vbOKCancel, "Brisanje Job-a...")
        If msgArh = DialogResult.OK Then
            If My.Computer.FileSystem.FileExists(datIzb) Then
                My.Computer.FileSystem.DeleteFile(datIzb, FileIO.UIOption.OnlyErrorDialogs, FileIO.RecycleOption.SendToRecycleBin)
            End If
            ' Ponovno osveži vsebino seznama
            PreberiJobe()
        End If
    End Sub

    Private Sub ToolStripButton1_Click(sender As Object, e As EventArgs) Handles ToolStripButton1.Click
        ' Arhiviraj izbran jprojekt

    End Sub

    Private Sub ToolStripButton2_Click(sender As Object, e As EventArgs) Handles ToolStripButton2.Click
        ' Izbriši izbran projekt

    End Sub
End Class